/*
[All buttons 0, 1 on press]

RA0, RA1, RA2 are G(0), 1, 2 buttons inside the Lift.

RA3 = Call button @ floor 2        [Only Down]

RA4 = Call button @ floor 1        [Up]

RA5 = Call button @ floor 1        [Down]

RE0 = Call button @ floor G        [Only Up]

[always 1, 0 on cabin detect]

RD4 = Sensor @ G(0)

RD5 = Sensor @ 1

RD6 = Sensor @ 2
*/

void Up();
void Down();
void Stop_Motor();
void Zero();
void One();
void Two();

void Up() {
      Delay_ms(40);
      PWM1_Set_Duty(153);
      PWM1_Start();
}

void Down() {
      Delay_ms(40);
      PWM1_Set_Duty(51);
      PWM1_Start();
}

void Stop_Motor() {
      Delay_ms(40);
      PWM1_Stop();
      PWM1_Set_Duty(153);
}

/*
void Zero() {
    PORTD = (PORTD & 0x71);        //kindly write comments here a small explanation of these lines
    PORTC = (PORTC & 0x0F);
}

void One() {
    PORTD = (PORTD & 0x71) | 0x04;     //kindly write in comments a small explanation of these lines
    PORTC = (PORTC & 0x0F) | 0x10;
}

void Two() {
    PORTD = (PORTD & 0x71) | 0x08;
    PORTC = (PORTC & 0x0F) | 0x20;
}
*/

void main() {

      ADCON1 = 0x87;  //10000111 congigure porte as digital input output port
      CMCON = 0x07;
      TRISA = 0xFF;
      PORTA = 0x00;
      TRISE = 0x07;
      TRISC = 0x00;
      PORTC = 0x00;
      TRISD = 0x70;
      PORTD = 0x00;
      PORTE = 0x00;

      PWM1_Init(5000);  // I CHECK THIS CODE IN DEBUGGER PROGRAM STUCKED in this command
      
      while(1) {

             if((PORTA == 0x12) && (PORTE = 0x00)) {
                      Delay_ms(40);
                      if((PORTA == 0x12) && (PORTE = 0x00)) {
                              Up();
                      }
             }
             else if((PORTA == 0x01) && (PORTE = 0x00)) {
                      Delay_ms(40);
                      if((PORTA == 0x01) && (PORTE = 0x00)) {
                             Down();

                      }
             }
             
             if((PORTD & 0x70) == 0x60) {
                     PORTD = (PORTD & 0x71);
             }
             else if((PORTD & 0x70) == 0x50) {
                     PORTD = (PORTD & 0x71) | 0x04;
             }
             else if((PORTD & 0x70) == 0x30) {
                     PORTD = (PORTD & 0x71) | 0x08;
             }


      }
}